## lxd 2.0.0~beta4

=== debian/changelog ===
lxd (2.0.0~beta4-0ubuntu5~ubuntu14.04.1) trusty-backports; urgency=medium

  * Backport to trusty (LP: #1549874)
  * Arch-restrict all binaries to i386 amd64 armhf.
    The other architectures require a recent gccgo5 and golang 1.5 to build.
  * Add a versioned build-dependency on trusty-backports' golang.
  * Add a versioned depends for lxd on trusty-backports' lxc.
  * Turn bundled dependencies back on.
  * Patch golang-systemd to build on Go 1.3.

 -- Stéphane Graber <stgraber@ubuntu.com>  Thu, 25 Feb 2016 12:51:46 -0500

=== debian/tests/control ===
Tests: exercise
Depends: acl,
         busybox-static,
         curl,
         golang-go,
         jq,
         git,
         gettext,
         make,
         pep8,
         pyflakes,
         shellcheck,
         sqlite3,
         uuid-runtime,
         @
Restrictions: needs-root allow-stderr

## lxd 2.0.0~rc1

=== debian/changelog ===
lxd (2.0.0~rc1-0ubuntu2~ubuntu14.04.1) trusty-backports; urgency=medium

  * Backport to trusty
  * Arch-restrict all binaries to i386 amd64 armhf.
    The other architectures require a recent gccgo5 and golang 1.5 to build.
  * Add a versioned build-dependency on trusty-backports' golang.
  * Add a versioned depends for lxd on trusty-backports' lxc.
  * Turn bundled dependencies back on.
  * Patch golang-systemd to build on Go 1.3.

 -- Stéphane Graber <stgraber@ubuntu.com>  Thu, 03 Mar 2016 12:28:15 -0500

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

PKGDIR=debian/tmp
VERSION=$(shell grep "var Version" $(CURDIR)/shared/flex.go | cut -d'"' -f2)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# temporary build path (see http://golang.org/doc/code.html#GOPATH)
export DH_GOPKG := github.com/lxc/lxd
export GOPATH := $(CURDIR)/obj-$(DEB_BUILD_GNU_TYPE)
export USE_EMBEDDED := true

%:
	dh $@ --with systemd --buildsystem=golang --with=golang

# Ugly workaround for bundled dependencies
override_dh_auto_configure:
	dh_auto_configure

	# dh-golang's configure has copied the source tree into GOPATH. But
	# because lxd gets some dependencies from the archive and some from
	# the copies bundled in dist, we have to unpick a bunch of what it has
	# done and set it up again.

	# Remove the extra copy of dist dh-golang has copied onto GOPATH (or
	# when dh-golang tries to run go install github.com/lxc/lxd/... things
	# get very confused).
	rm -Rf ${GOPATH}/src/github.com/lxc/lxd/dist

	# Move the lxd source aside while we do this.
	mv ${GOPATH}/src/github.com/lxc/lxd ${GOPATH}/lxd.tmp

	# Clean GOPATH.
	rm -Rf ${GOPATH}/src

ifeq ($(USE_EMBEDDED), true)
	# If we get all dependencies from dist, just copy it onto GOPATH.
	cp -R dist/src ${GOPATH}

	# But not the symlink for lxd.
	rm -f ${GOPATH}/src/github.com/lxc/lxd
else
	# If not, link depedencies from dist or from where the distro package
	# has installed it, as appropriate.

	# Packaged dependencies
	debian/helpers/link-from-installed github.com/coreos/go-systemd
	debian/helpers/link-from-installed github.com/dustinkirkland/golang-petname
	debian/helpers/link-from-installed github.com/golang/protobuf
	debian/helpers/link-from-installed github.com/gorilla/context
	debian/helpers/link-from-installed github.com/gorilla/mux
	debian/helpers/link-from-installed github.com/mattn/go-sqlite3
	debian/helpers/link-from-installed github.com/olekukonko/tablewriter
	debian/helpers/link-from-installed github.com/pborman/uuid
	debian/helpers/link-from-installed github.com/syndtr/gocapability
	debian/helpers/link-from-installed golang.org/x/crypto
	debian/helpers/link-from-installed gopkg.in/tomb.v2
	debian/helpers/link-from-installed gopkg.in/yaml.v2

	# Packages that aren't in the archive
	debian/helpers/link-from-bundled github.com/mattn/go-colorable
	debian/helpers/link-from-bundled gopkg.in/flosch/pongo2.v3
	debian/helpers/link-from-bundled gopkg.in/inconshreveable/log15.v2
	debian/helpers/link-from-bundled gopkg.in/lxc/go-lxc.v2

	# Packages that aren't in main yet
	debian/helpers/link-from-bundled github.com/gorilla/websocket
	debian/helpers/link-from-bundled github.com/gosexy/gettext
endif

	# And put the lxd source back again.
	mkdir -p ${GOPATH}/src/github.com/lxc/
	mv ${GOPATH}/lxd.tmp ${GOPATH}/src/github.com/lxc/lxd

override_dh_install:
	# Install the manpages
	mkdir -p $(PKGDIR)/usr/share/man/man1/
	help2man $(PKGDIR)/usr/bin/fuidshift -n "uid/gid shifter" --no-info > $(PKGDIR)/usr/share/man/man1/fuidshift.1
	help2man $(PKGDIR)/usr/bin/lxc -n "The container hypervisor - client" --no-info > $(PKGDIR)/usr/share/man/man1/lxc.1
	help2man $(PKGDIR)/usr/bin/lxd -n "The container hypervisor - daemon" --no-info > $(PKGDIR)/usr/share/man/man1/lxd.1
	help2man scripts/lxd-images -n "The container hypervisor - image importer" --version-string=$(VERSION) --no-info > $(PKGDIR)/usr/share/man/man1/lxd-images.1

	mkdir -p $(PKGDIR)/usr/share/bash-completion/completions/
	cp config/bash/lxd-client $(PKGDIR)/usr/share/bash-completion/completions

	# Prepare dev package
	rm -Rf $(PKGDIR)/usr/share/gocode/src/github.com/lxc/
	mkdir -p $(PKGDIR)/usr/share/gocode/src/github.com/lxc/
	cp -RL ${GOPATH}/src/github.com/lxc/lxd $(PKGDIR)/usr/share/gocode/src/github.com/lxc/
	rm -Rf $(PKGDIR)/usr/share/gocode/src/github.com/lxc/lxd/dist

	# Trigger normal dh_install
	dh_install

override_dh_installinit:
	# We handle starting and restarting things ourselves
	dh_systemd_enable -plxd --name=lxd-containers lxd-containers.service
	dh_installinit -plxd --no-start
	dh_installinit -plxd --name=lxd-containers --no-start --noscripts
	dh_systemd_start -plxd lxd-containers.service --no-restart-on-upgrade

	# Update arch-specific paths
	sed -i "s#@LIBEXECDIR@#/usr/lib/${DEB_HOST_MULTIARCH}#g" debian/lxd/lib/systemd/system/lxd.service
	sed -i "s#@LIBEXECDIR@#/usr/lib/${DEB_HOST_MULTIARCH}#g" debian/lxd/etc/init/lxd.conf
	sed -i "s#@LIBEXECDIR@#/usr/lib/${DEB_HOST_MULTIARCH}#g" debian/lxd/etc/init.d/lxd

override_dh_systemd_start:
	echo "Not running dh_systemd_start"

override_dh_auto_test:
	echo "The testsuite requires privileges and so is run through autopkgtest"

## lxd 2.0.0~rc3

=== debian/changelog ===
lxd (2.0.0~rc3-0ubuntu3~ubuntu14.04.1) trusty-backports; urgency=medium

  * Backport to trusty
  * Arch-restrict all binaries to i386 amd64 armhf.
    The other architectures require a recent gccgo5 and golang 1.5 to build.
  * Add a versioned build-dependency on trusty-backports' golang.
  * Add a versioned depends for lxd on trusty-backports' lxc.
  * Turn bundled dependencies back on.
  * Patch golang-systemd to build on Go 1.3.

 -- Stéphane Graber <stgraber@ubuntu.com>  Tue, 15 Mar 2016 21:32:55 -0400

## lxd 2.0.0~rc4

=== debian/changelog ===
lxd (2.0.0~rc4-0ubuntu1~ubuntu14.04.1) trusty-backports; urgency=medium

  * Backport to trusty
  * Arch-restrict all binaries to i386 amd64 armhf.
    The other architectures require a recent gccgo5 and golang 1.5 to build.
  * Add a versioned build-dependency on trusty-backports' golang.
  * Add a versioned depends for lxd on trusty-backports' lxc.
  * Turn bundled dependencies back on.
  * Patch golang-systemd to build on Go 1.3.

 -- Stéphane Graber <stgraber@ubuntu.com>  Wed, 16 Mar 2016 23:10:27 -0400

=== debian/control ===
Source: lxd
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Standards-Version: 3.9.6
Homepage: https://linuxcontainers.org/
Vcs-Git: git://github.com/lxc/lxd-pkg-ubuntu
Vcs-Browser: https://github.com/lxc/lxd-pkg-ubuntu
Build-Depends: debhelper (>= 9),
               dh-golang,
               dh-systemd,
               golang-go [i386 amd64 armhf],
               help2man,
               lxc-dev (>= 1.1.0~),
               pkg-config,
               protobuf-compiler
XS-Testsuite: autopkgtest

Package: lxd-client
Architecture: i386 amd64 armhf
Depends: ${misc:Depends}, ${shlibs:Depends}
Built-Using: ${misc:Built-Using}
Suggests: lxd
Description: Container hypervisor based on LXC - client
 LXD offers a REST API to remotely manage containers over the network,
 using an image based workflow and with support for live migration.
 .
 This package contains the command line client.

Package: lxd
Architecture: i386 amd64 armhf
Depends: acl,
         adduser,
         gnupg,
         liblxc1 (>= 1.1.0~),
         lxc (>= 1.1.0~),
         lxcfs,
         netcat-openbsd,
         python3,
         rsync,
         uidmap,
         xz-utils,
         ${misc:Depends},
         ${shlibs:Depends}
Built-Using: ${misc:Built-Using}
Recommends: lxd-client
Suggests: criu, lxd-tools
Description: Container hypervisor based on LXC - daemon
 LXD offers a REST API to remotely manage containers over the network,
 using an image based workflow and with support for live migration.
 .
 This package contains the LXD daemon.

Package: lxc2
Architecture: all
Depends: lxd, lxd-client, ${misc:Depends}
Priority: extra
Section: metapackages
Description: Container hypervisor based on LXC - metapackage
 LXD offers a REST API to remotely manage containers over the network,
 using an image based workflow and with support for live migration.
 .
 This is a dummy metapackage to install LXD and its client.

Package: lxd-tools
Architecture: i386 amd64 armhf
Depends: ${misc:Depends}, ${shlibs:Depends}
Built-Using: ${misc:Built-Using}
Description: Container hypervisor based on LXC - extra tools
 LXD offers a REST API to remotely manage containers over the network,
 using an image based workflow and with support for live migration.
 .
 This package contains extra tools provided with LXD.
  - fuidshift - A tool to map/unmap filesystem uids/gids

Package: golang-github-lxc-lxd-dev
Architecture: all
Depends: golang-go, lxc-dev, pkg-config, ${misc:Depends}, ${shlibs:Depends}
Description: Container hypervisor based on LXC - go source
 LXD offers a REST API to remotely manage containers over the network,
 using an image based workflow and with support for live migration.
 .
 This package contains the source tree of the lxd project.

=== debian/rules ===
--- 
+++ 
@@ -52,6 +52,7 @@
 	debian/helpers/link-from-installed github.com/golang/protobuf
 	debian/helpers/link-from-installed github.com/gorilla/context
 	debian/helpers/link-from-installed github.com/gorilla/mux
+	debian/helpers/link-from-installed github.com/gosexy/gettext
 	debian/helpers/link-from-installed github.com/mattn/go-sqlite3
 	debian/helpers/link-from-installed github.com/olekukonko/tablewriter
 	debian/helpers/link-from-installed github.com/pborman/uuid
@@ -68,7 +69,6 @@
 
 	# Packages that aren't in main yet
 	debian/helpers/link-from-bundled github.com/gorilla/websocket
-	debian/helpers/link-from-bundled github.com/gosexy/gettext
 endif
 
 	# And put the lxd source back again.

## lxd 2.0.0~rc5

=== debian/changelog ===
lxd (2.0.0~rc5-0ubuntu1~ubuntu14.04.2) trusty-backports; urgency=medium

  * It's debian/patches/series, not debian/series...

 -- Stéphane Graber <stgraber@ubuntu.com>  Tue, 22 Mar 2016 01:22:26 -0400

lxd (2.0.0~rc5-0ubuntu1~ubuntu14.04.1) trusty-backports; urgency=medium

  * Backport to trusty
  * Arch-restrict all binaries to i386 amd64 armhf.
    The other architectures require a recent gccgo5 and golang 1.5 to build.
  * Add a versioned build-dependency on trusty-backports' golang.
  * Add a versioned depends for lxd on trusty-backports' lxc.
  * Turn bundled dependencies back on.
  * Patch golang-systemd to build on Go 1.3.

 -- Stéphane Graber <stgraber@ubuntu.com>  Tue, 22 Mar 2016 01:11:26 -0400

=== debian/rules ===
--- 
+++ 
@@ -81,7 +81,6 @@
 	help2man $(PKGDIR)/usr/bin/fuidshift -n "uid/gid shifter" --no-info > $(PKGDIR)/usr/share/man/man1/fuidshift.1
 	help2man $(PKGDIR)/usr/bin/lxc -n "The container hypervisor - client" --no-info > $(PKGDIR)/usr/share/man/man1/lxc.1
 	help2man $(PKGDIR)/usr/bin/lxd -n "The container hypervisor - daemon" --no-info > $(PKGDIR)/usr/share/man/man1/lxd.1
-	help2man scripts/lxd-images -n "The container hypervisor - image importer" --version-string=$(VERSION) --no-info > $(PKGDIR)/usr/share/man/man1/lxd-images.1
 
 	mkdir -p $(PKGDIR)/usr/share/bash-completion/completions/
 	cp config/bash/lxd-client $(PKGDIR)/usr/share/bash-completion/completions

## lxd 2.0.0~rc7

=== debian/changelog ===
lxd (2.0.0~rc7-0ubuntu1~ubuntu14.04.1) trusty-backports; urgency=medium

  * Backport to trusty
  * Arch-restrict all binaries to i386 amd64 armhf.
    The other architectures require a recent gccgo5 and golang 1.5 to build.
  * Add a versioned build-dependency on trusty-backports' golang.
  * Add a versioned depends for lxd on trusty-backports' lxc.
  * Turn bundled dependencies back on.
  * Patch golang-systemd to build on Go 1.3.
  * Remove bash completion profile (conflicts with LXC's).

 -- Stéphane Graber <stgraber@ubuntu.com>  Mon, 28 Mar 2016 23:49:32 -0400

=== debian/control ===
--- 
+++ 
@@ -21,6 +21,8 @@
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Built-Using: ${misc:Built-Using}
 Suggests: lxd
+Breaks: lxc1 (<= 2.0.0~rc13-0ubuntu2~)
+Replaces: lxc1 (<= 2.0.0~rc13-0ubuntu2~)
 Description: Container hypervisor based on LXC - client
  LXD offers a REST API to remotely manage containers over the network,
  using an image based workflow and with support for live migration.

=== debian/rules ===
--- 
+++ 
@@ -82,9 +82,6 @@
 	help2man $(PKGDIR)/usr/bin/lxc -n "The container hypervisor - client" --no-info > $(PKGDIR)/usr/share/man/man1/lxc.1
 	help2man $(PKGDIR)/usr/bin/lxd -n "The container hypervisor - daemon" --no-info > $(PKGDIR)/usr/share/man/man1/lxd.1
 
-	mkdir -p $(PKGDIR)/usr/share/bash-completion/completions/
-	cp config/bash/lxd-client $(PKGDIR)/usr/share/bash-completion/completions
-
 	# Prepare dev package
 	rm -Rf $(PKGDIR)/usr/share/gocode/src/github.com/lxc/
 	mkdir -p $(PKGDIR)/usr/share/gocode/src/github.com/lxc/
@@ -96,8 +93,10 @@
 
 override_dh_installinit:
 	# We handle starting and restarting things ourselves
+	dh_systemd_enable -plxd --name=lxd-bridge lxd-bridge.service
 	dh_systemd_enable -plxd --name=lxd-containers lxd-containers.service
 	dh_installinit -plxd --no-start
+	dh_installinit -plxd --name=lxd-bridge --no-start --noscripts
 	dh_installinit -plxd --name=lxd-containers --no-start --noscripts
 	dh_systemd_start -plxd lxd-containers.service --no-restart-on-upgrade

## lxd 2.0.0~rc8

=== debian/changelog ===
lxd (2.0.0~rc8-0ubuntu2~ubuntu14.04.1) trusty-backports; urgency=medium

  * Backport to trusty
  * Arch-restrict all binaries to i386 amd64 armhf.
    The other architectures require a recent gccgo5 and golang 1.5 to build.
  * Add a versioned build-dependency on trusty-backports' golang.
  * Add a versioned depends for lxd on trusty-backports' lxc.
  * Turn bundled dependencies back on.
  * Patch golang-systemd to build on Go 1.3.
  * Remove bash completion profile (conflicts with LXC's).

 -- Stéphane Graber <stgraber@ubuntu.com>  Fri, 01 Apr 2016 21:12:43 -0400

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
 Build-Depends: debhelper (>= 9),
                dh-golang,
                dh-systemd,
-               golang-go [i386 amd64 armhf],
+               golang-go,
                help2man,
                lxc-dev (>= 1.1.0~),
                pkg-config,

=== debian/rules ===
--- 
+++ 
@@ -52,7 +52,9 @@
 	debian/helpers/link-from-installed github.com/golang/protobuf
 	debian/helpers/link-from-installed github.com/gorilla/context
 	debian/helpers/link-from-installed github.com/gorilla/mux
+	debian/helpers/link-from-installed github.com/gorilla/websocket
 	debian/helpers/link-from-installed github.com/gosexy/gettext
+	debian/helpers/link-from-installed github.com/mattn/go-colorable
 	debian/helpers/link-from-installed github.com/mattn/go-sqlite3
 	debian/helpers/link-from-installed github.com/olekukonko/tablewriter
 	debian/helpers/link-from-installed github.com/pborman/uuid
@@ -62,13 +64,9 @@
 	debian/helpers/link-from-installed gopkg.in/yaml.v2
 
 	# Packages that aren't in the archive
-	debian/helpers/link-from-bundled github.com/mattn/go-colorable
 	debian/helpers/link-from-bundled gopkg.in/flosch/pongo2.v3
 	debian/helpers/link-from-bundled gopkg.in/inconshreveable/log15.v2
 	debian/helpers/link-from-bundled gopkg.in/lxc/go-lxc.v2
-
-	# Packages that aren't in main yet
-	debian/helpers/link-from-bundled github.com/gorilla/websocket
 endif
 
 	# And put the lxd source back again.

## lxd 2.0.0~rc9

=== debian/changelog ===
lxd (2.0.0~rc9-0ubuntu5~ubuntu14.04.1) trusty-backports; urgency=medium

  * Backport to trusty
  * Build using golang-1.6-go.
  * Arch-restrict all binaries to amd64, arm64, armhf, i386, ppc64el.
    powerpc isn't supported by golang-go.
  * Use bundled dependencies instead of archive versions (which don't exist).

 -- Stéphane Graber <stgraber@ubuntu.com>  Sun, 10 Apr 2016 23:23:55 -0400

=== debian/control ===
--- 
+++ 
@@ -2,14 +2,14 @@
 Section: admin
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-Standards-Version: 3.9.6
+Standards-Version: 3.9.7
 Homepage: https://linuxcontainers.org/
-Vcs-Git: git://github.com/lxc/lxd-pkg-ubuntu
+Vcs-Git: https://github.com/lxc/lxd-pkg-ubuntu
 Vcs-Browser: https://github.com/lxc/lxd-pkg-ubuntu
 Build-Depends: debhelper (>= 9),
                dh-golang,
                dh-systemd,
-               golang-go,
+               golang-1.6-go,
                help2man,
                lxc-dev (>= 1.1.0~),
                pkg-config,
@@ -17,7 +17,7 @@
 XS-Testsuite: autopkgtest
 
 Package: lxd-client
-Architecture: i386 amd64 armhf
+Architecture: amd64 arm64 armhf i386 ppc64el
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Built-Using: ${misc:Built-Using}
 Suggests: lxd
@@ -30,15 +30,15 @@
  This package contains the command line client.
 
 Package: lxd
-Architecture: i386 amd64 armhf
+Architecture: amd64 arm64 armhf i386 ppc64el
+Pre-Depends: debconf
 Depends: acl,
          adduser,
-         gnupg,
+         dnsmasq-base,
+         iptables,
          liblxc1 (>= 1.1.0~),
-         lxc (>= 1.1.0~),
          lxcfs,
          netcat-openbsd,
-         python3,
          rsync,
          uidmap,
          xz-utils,
@@ -65,7 +65,7 @@
  This is a dummy metapackage to install LXD and its client.
 
 Package: lxd-tools
-Architecture: i386 amd64 armhf
+Architecture: amd64 arm64 armhf i386 ppc64el
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Built-Using: ${misc:Built-Using}
 Description: Container hypervisor based on LXC - extra tools

=== debian/rules ===
--- 
+++ 
@@ -12,6 +12,9 @@
 export DH_GOPKG := github.com/lxc/lxd
 export GOPATH := $(CURDIR)/obj-$(DEB_BUILD_GNU_TYPE)
 export USE_EMBEDDED := true
+
+# use golang-1.6
+export PATH := /usr/lib/go-1.6/bin:$(PATH)
 
 %:
 	dh $@ --with systemd --buildsystem=golang --with=golang
@@ -60,13 +63,11 @@
 	debian/helpers/link-from-installed github.com/pborman/uuid
 	debian/helpers/link-from-installed github.com/syndtr/gocapability
 	debian/helpers/link-from-installed golang.org/x/crypto
+	debian/helpers/link-from-installed gopkg.in/flosch/pongo2.v3
+	debian/helpers/link-from-installed gopkg.in/inconshreveable/log15.v2
+	debian/helpers/link-from-installed gopkg.in/lxc/go-lxc.v2
 	debian/helpers/link-from-installed gopkg.in/tomb.v2
 	debian/helpers/link-from-installed gopkg.in/yaml.v2
-
-	# Packages that aren't in the archive
-	debian/helpers/link-from-bundled gopkg.in/flosch/pongo2.v3
-	debian/helpers/link-from-bundled gopkg.in/inconshreveable/log15.v2
-	debian/helpers/link-from-bundled gopkg.in/lxc/go-lxc.v2
 endif
 
 	# And put the lxd source back again.
@@ -79,6 +80,9 @@
 	help2man $(PKGDIR)/usr/bin/fuidshift -n "uid/gid shifter" --no-info > $(PKGDIR)/usr/share/man/man1/fuidshift.1
 	help2man $(PKGDIR)/usr/bin/lxc -n "The container hypervisor - client" --no-info > $(PKGDIR)/usr/share/man/man1/lxc.1
 	help2man $(PKGDIR)/usr/bin/lxd -n "The container hypervisor - daemon" --no-info > $(PKGDIR)/usr/share/man/man1/lxd.1
+
+	mkdir -p $(PKGDIR)/usr/share/bash-completion/completions/
+	cp config/bash/lxd-client $(PKGDIR)/usr/share/bash-completion/completions/lxc
 
 	# Prepare dev package
 	rm -Rf $(PKGDIR)/usr/share/gocode/src/github.com/lxc/

## lxd 2.0.0

=== Makefile ===
DOMAIN=lxd
POFILES=$(wildcard po/*.po)
MOFILES=$(patsubst %.po,%.mo,$(POFILES))
LINGUAS=$(basename $(POFILES))
POTFILE=po/$(DOMAIN).pot

# dist is primarily for use when packaging; for development we still manage
# dependencies via `go get` explicitly.
# TODO: use git describe for versioning
VERSION=$(shell grep "var Version" shared/flex.go | cut -d'"' -f2)
ARCHIVE=lxd-$(VERSION).tar

.PHONY: default
default:
	# Must run twice due to go get race
	-go get -t -v -d ./...
	-go get -t -v -d ./...
	go install -v $(DEBUG) ./...
	@echo "LXD built successfully"

.PHONY: client
client:
	# Must run twice due to go get race
	-go get -t -v -d ./...
	-go get -t -v -d ./...
	go install -v $(DEBUG) ./lxc
	@echo "LXD client built successfully"

.PHONY: update
update:
	# Must run twice due to go get race
	-go get -t -v -d -u ./...
	go get -t -v -d -u ./...
	@echo "Dependencies updated"

# This only needs to be done when migrate.proto is actually changed; since we
# commit the .pb.go in the tree and it's not expected to change very often,
# it's not a default build step.
.PHONY: protobuf
protobuf:
	protoc --go_out=. ./lxd/migrate.proto

.PHONY: check
check: default
	go get -v -x github.com/remyoudompheng/go-misc/deadcode
	go test -v ./...
	cd test && ./main.sh

gccgo:
	go build -compiler gccgo ./...
	@echo "LXD built successfully with gccgo"

.PHONY: dist
dist:
	rm -Rf lxd-$(VERSION) $(ARCHIVE) $(ARCHIVE).gz
	mkdir -p lxd-$(VERSION)/dist
	-GOPATH=$(shell pwd)/lxd-$(VERSION)/dist go get -t -v -d ./...
	GOPATH=$(shell pwd)/lxd-$(VERSION)/dist go get -t -v -d ./...
	rm -rf $(shell pwd)/lxd-$(VERSION)/dist/src/github.com/lxc/lxd
	ln -s ../../../.. ./lxd-$(VERSION)/dist/src/github.com/lxc/lxd
	git archive --prefix=lxd-$(VERSION)/ --output=$(ARCHIVE) HEAD
	tar -uf $(ARCHIVE) --exclude-vcs lxd-$(VERSION)/
	gzip -9 $(ARCHIVE)
	rm -Rf dist lxd-$(VERSION) $(ARCHIVE)

.PHONY: i18n update-po update-pot build-mo static-analysis
i18n: update-pot

po/%.mo: po/%.po
	msgfmt --statistics -o $@ $<

po/%.po: po/$(DOMAIN).pot
	msgmerge -U po/$*.po po/$(DOMAIN).pot

update-po:
	-for lang in $(LINGUAS); do\
	    msgmerge -U $$lang.po po/$(DOMAIN).pot; \
	    rm -f $$lang.po~; \
	done

update-pot:
	go get -v -x github.com/ubuntu-core/snappy/i18n/xgettext-go/
	xgettext-go -o po/$(DOMAIN).pot --add-comments-tag=TRANSLATORS: --sort-output --package-name=$(DOMAIN) --msgid-bugs-address=lxc-devel@lists.linuxcontainers.org --keyword=i18n.G --keyword-plural=i18n.NG *.go shared/*.go lxc/*.go lxd/*.go


build-mo: $(MOFILES)

static-analysis:
	/bin/bash -x -c ". test/static_analysis.sh; static_analysis"

tags: *.go lxd/*.go shared/*.go lxc/*.go
	find . | grep \.go | grep -v git | grep -v .swp | grep -v vagrant | xargs gotags > tags

=== dist/src/gopkg.in/lxc/go-lxc.v2/examples/Makefile ===
NO_COLOR=\033[0m
OK_COLOR=\033[0;32m

ALL_GO_FILES = $(wildcard *.go)
ALL_FILES = $(patsubst %.go,%,$(ALL_GO_FILES))

all: $(ALL_FILES)

define PROGRAM_template
$(1): format vet lint
	@echo "$(OK_COLOR)==> Building $(1) $(NO_COLOR)"
	@go build $(1).go
endef

$(foreach prog,$(ALL_FILES),$(eval $(call PROGRAM_template,$(prog))))

clean:
	@$(foreach file,$(ALL_FILES),rm -f $(file);)

format:
	@echo "$(OK_COLOR)==> Formatting the code $(NO_COLOR)"
	@gofmt -s -w *.go
	@goimports -w *.go

vet:
	@echo "$(OK_COLOR)==> Running go vet $(NO_COLOR)"
	@`which go` vet .

lint:
	@echo "$(OK_COLOR)==> Running golint $(NO_COLOR)"
	@`which golint` .

.PHONY: all clean format vet lint

=== dist/src/github.com/golang/protobuf/jsonpb/jsonpb_test_proto/Makefile ===
# Go support for Protocol Buffers - Google's data interchange format
#
# Copyright 2015 The Go Authors.  All rights reserved.
# https://github.com/golang/protobuf
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     * Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above
# copyright notice, this list of conditions and the following disclaimer
# in the documentation and/or other materials provided with the
# distribution.
#     * Neither the name of Google Inc. nor the names of its
# contributors may be used to endorse or promote products derived from
# this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

regenerate:
	protoc --go_out=Mgoogle/protobuf/duration.proto=github.com/golang/protobuf/ptypes/duration,Mgoogle/protobuf/struct.proto=github.com/golang/protobuf/ptypes/struct,Mgoogle/protobuf/timestamp.proto=github.com/golang/protobuf/ptypes/timestamp,Mgoogle/protobuf/wrappers.proto=github.com/golang/protobuf/ptypes/wrappers:. *.proto

=== debian/rules ===
--- 
+++ 
@@ -11,10 +11,7 @@
 # temporary build path (see http://golang.org/doc/code.html#GOPATH)
 export DH_GOPKG := github.com/lxc/lxd
 export GOPATH := $(CURDIR)/obj-$(DEB_BUILD_GNU_TYPE)
-export USE_EMBEDDED := true
-
-# use golang-1.6
-export PATH := /usr/lib/go-1.6/bin:$(PATH)
+export USE_EMBEDDED := false
 
 %:
 	dh $@ --with systemd --buildsystem=golang --with=golang
@@ -90,6 +87,9 @@
 	cp -RL ${GOPATH}/src/github.com/lxc/lxd $(PKGDIR)/usr/share/gocode/src/github.com/lxc/
 	rm -Rf $(PKGDIR)/usr/share/gocode/src/github.com/lxc/lxd/dist
 
+	# Apparmor
+	dh_apparmor -p lxd --profile-name=usr.lib.lxd.lxd-bridge-proxy
+
 	# Trigger normal dh_install
 	dh_install

=== debian/tests/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
          gettext,
          make,
          pep8,
-         pyflakes,
+         pyflakes3,
          shellcheck,
          sqlite3,
          uuid-runtime,

## lxd 2.0.2

=== dist/src/github.com/golang/protobuf/protoc-gen-go/testdata/Makefile ===
# Go support for Protocol Buffers - Google's data interchange format
#
# Copyright 2010 The Go Authors.  All rights reserved.
# https://github.com/golang/protobuf
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     * Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above
# copyright notice, this list of conditions and the following disclaimer
# in the documentation and/or other materials provided with the
# distribution.
#     * Neither the name of Google Inc. nor the names of its
# contributors may be used to endorse or promote products derived from
# this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

all:
	@echo run make test

include ../../Make.protobuf

test:	golden testbuild

#test:	golden testbuild extension_test
#	./extension_test
#	@echo PASS

my_test/test.pb.go: my_test/test.proto
	protoc --go_out=Mmulti/multi1.proto=github.com/golang/protobuf/protoc-gen-go/testdata/multi:. $<

golden:
	make -B my_test/test.pb.go
	sed -i '/return.*fileDescriptor/d' my_test/test.pb.go
	sed -i '/^var fileDescriptor/,/^}/d' my_test/test.pb.go
	gofmt -w my_test/test.pb.go
	diff -w my_test/test.pb.go my_test/test.pb.go.golden

nuke:	clean

testbuild:	regenerate
	go test

regenerate:
	# Invoke protoc once to generate three independent .pb.go files in the same package.
	protoc --go_out=. multi/multi{1,2,3}.proto

#extension_test:	extension_test.$O
#	$(LD) -L. -o $@ $<

#multi.a: multi3.pb.$O multi2.pb.$O multi1.pb.$O
#	rm -f multi.a
#	$(QUOTED_GOBIN)/gopack grc $@ $<

#test.pb.go:	imp.pb.go
#multi1.pb.go:	multi2.pb.go multi3.pb.go
#main.$O: imp.pb.$O test.pb.$O multi.a
#extension_test.$O: extension_base.pb.$O extension_extra.pb.$O extension_user.pb.$O

=== debian/changelog ===
lxd (2.0.2-0ubuntu1~ubuntu14.04.1) trusty-backports; urgency=medium

  * Backport to trusty
  * Build using golang-1.6-go.
  * Arch-restrict all binaries to amd64, arm64, armhf, i386, ppc64el.
    powerpc isn't supported by golang-go.
  * Use bundled dependencies instead of archive versions (which don't exist).
  * Re-introduce dependency on lxc until LXC 2.0 is backported.

 -- Stéphane Graber <stgraber@ubuntu.com>  Mon, 06 Jun 2016 23:42:31 -0400

=== debian/control ===
--- 
+++ 
@@ -7,6 +7,7 @@
 Vcs-Git: https://github.com/lxc/lxd-pkg-ubuntu
 Vcs-Browser: https://github.com/lxc/lxd-pkg-ubuntu
 Build-Depends: debhelper (>= 9),
+               dh-apparmor,
                dh-golang,
                dh-systemd,
                golang-1.6-go,
@@ -37,6 +38,7 @@
          dnsmasq-base,
          iptables,
          liblxc1 (>= 1.1.0~),
+         lxc (>= 1.1.0~),
          lxcfs,
          netcat-openbsd,
          rsync,

## lxd 2.0.3

=== debian/changelog ===
lxd (2.0.3-0ubuntu2~ubuntu14.04.1) trusty-backports; urgency=medium

  * Backport to trusty
  * Build using golang-1.6-go.
  * Arch-restrict all binaries to amd64, arm64, armhf, i386, ppc64el.
    powerpc isn't supported by golang-go.
  * Use bundled dependencies instead of archive versions (which don't exist).

 -- Stéphane Graber <stgraber@ubuntu.com>  Thu, 30 Jun 2016 13:59:34 -0400

=== debian/control ===
--- 
+++ 
@@ -38,10 +38,10 @@
          dnsmasq-base,
          iptables,
          liblxc1 (>= 1.1.0~),
-         lxc (>= 1.1.0~),
          lxcfs,
          netcat-openbsd,
          rsync,
+         squashfs-tools,
          uidmap,
          xz-utils,
          ${misc:Depends},

=== debian/rules ===
--- 
+++ 
@@ -11,7 +11,10 @@
 # temporary build path (see http://golang.org/doc/code.html#GOPATH)
 export DH_GOPKG := github.com/lxc/lxd
 export GOPATH := $(CURDIR)/obj-$(DEB_BUILD_GNU_TYPE)
-export USE_EMBEDDED := false
+export USE_EMBEDDED := true
+
+# use golang-1.6
+export PATH := /usr/lib/go-1.6/bin:$(PATH)
 
 %:
 	dh $@ --with systemd --buildsystem=golang --with=golang

## lxd 2.0.4

=== debian/changelog ===
lxd (2.0.4-0ubuntu1~ubuntu14.04.1) trusty-backports; urgency=medium

  * Backport to trusty
  * Build using golang-1.6-go.
  * Arch-restrict all binaries to amd64, arm64, armhf, i386, ppc64el.
    powerpc isn't supported by golang-go.
  * Use bundled dependencies instead of archive versions (which don't exist).

 -- Stéphane Graber <stgraber@ubuntu.com>  Mon, 03 Oct 2016 12:57:33 -0400

lxd (2.0.4-0ubuntu1~ubuntu16.04.1) xenial; urgency=medium

  * New upstream bugfix release (2.0.4) (LP: #1615102)
    - /dev/net/tun is now a default device (always present)
    - lxd-bridge: dnsmasq is now configured with IPv6 name resolution
    - lxd-bridge: iptables rules now have a comment
    - "lxd init" now comes with reasonable defaults
    - The "images:" remote now uses simplestreams on new installations
    - "lxc image export" now always uses the image fingerprint as filename
    - Import progress is now reported for URL imports in "lxc image import"
    - apparmor: Add feature detection and clean things a bit
    - apparmor: Don't depend on the LXC apparmor profile
    - apparmor: Rename main two chunks of rules
    - apparmor: Setup a more modular apparmor profile
    - client: Don't share http client with go routines
    - client: Error when trying to remove a non-existent device
    - client: Fix API info reporting in "lxc info"
    - client: Fix spelling: permisson -> permission
    - client: Make client.websocket a public API
    - client: Make --version option visible
    - client: Relax constraints on WebsocketRecvStream args
    - client: Use named args for actionCmds
    - client/finger: Remove unused field from finger cmd
    - client/image: Fix image import from URL
    - client/list: fix concurrent read/write
    - client/list: Fix error handling and race in "lxc list"
    - client/pause: Add some additional help to lxc pause
    - client/profile: Add "lxc profile unset" to help message
    - daemon/container: Actually handle containers list error
    - daemon/container: Add sanity checks for common problems
    - daemon/container: Alphabetize device processing
    - daemon/container: Better errors when sanity checking devices
    - daemon/container: Better handle missing or invalid device types
    - daemon/container: Document and validate limits.*.priority values
    - The "images:" remote now uses simplestreams on new installations
    - "lxc image export" now always uses the image fingerprint as filename
    - Import progress is now reported for URL imports in "lxc image import"
    - apparmor: Add feature detection and clean things a bit
    - apparmor: Don't depend on the LXC apparmor profile
    - apparmor: Rename main two chunks of rules
    - apparmor: Setup a more modular apparmor profile
    - client: Don't share http client with go routines
    - client: Error when trying to remove a non-existent device
    - client: Fix API info reporting in "lxc info"
    - client: Fix spelling: permisson -> permission
    - client: Make client.websocket a public API
    - client: Make --version option visible
    - client: Relax constraints on WebsocketRecvStream args
    - client: Use named args for actionCmds
    - client/finger: Remove unused field from finger cmd
    - client/image: Fix image import from URL
    - client/list: fix concurrent read/write
    - client/list: Fix error handling and race in "lxc list"
    - client/pause: Add some additional help to lxc pause
    - client/profile: Add "lxc profile unset" to help message
    - daemon/container: Actually handle containers list error
    - daemon/container: Add sanity checks for common problems
    - daemon/container: Alphabetize device processing
    - daemon/container: Better errors when sanity checking devices
    - daemon/container: Better handle missing or invalid device types
    - daemon/container: Document and validate limits.*.priority values
    - daemon/container: Document image export target behavior and fix bugs
    - daemon/container: Don't unfreeze a container on stop
    - daemon/container: Fix flag name in init error message
    - daemon/container: Fix limits.disk.priority when set to 0
    - daemon/container: Fix nic hotplug with openvswitch
    - daemon/container: Fix unix-char/unix-block in nested containers
    - daemon/container: Improve check for invalid physical devices
    - daemon/container: Remember the return code in the non wait-for-websocket
    - daemon/container: Remove unused "name" argument from UnixDevice
    - daemon/container: Return more error information back to the user
    - daemon/container: Sort disk devices by their path before their names
    - daemon/container: Unfreeze frozen container on shutdown
    - daemon/db: Don't fail db upgrade if $LXD_DIR/containers doesn't exist
    - daemon/db: remove fuse device from docker profile
    - daemon/migration: fix tempdir handling
    - daemon/profile: Prevent using invalid profile names
    - daemon/zfs: Fix ZFS volume size on 32bit architectures
    - daemon/zfs: Only delete copy- snapshots on delete
    - daemon/zfs: Remove subvolume in zfs.ImageCreate error flow
    - doc: Add /dev/net/tun and /dev/fuse to docs
    - doc: Added command to install squashfs-tools in README.md
    - doc: Document config_get in pongo templates
    - doc: Fixed errors on api examples with curl
    - doc: Initial documentation for production use of LXD
    - doc: Shuffle packages a bit in README.md
    - lxd-bridge-proxy: Remove unused code
    - Makefile: Also have "make dist" run multiple go get
    - scripts: Make lxc-to-lxd work inside virtualenv
    - simplestreams: Fix size reporting
    - simplestreams: Handle images without labels
    - simplestreams: List images available as both squashfs and tar.xz
    - simplestreams: Properly deal with unset expiry
    - simplestreams: Set proper user-agent
    - simplestreams: Use the hashes in the right order
  * Cherry-pick from upstream:
    - 0002-Fix-for-newer-shellcheck


=== debian/control ===
--- 
+++ 
@@ -37,7 +37,7 @@
          adduser,
          dnsmasq-base,
          iptables,
-         liblxc1 (>= 1.1.0~),
+         liblxc1 (>= 2.0.0~),
          lxcfs,
          netcat-openbsd,
          rsync,

## lxd 2.0.5

=== debian/changelog ===
lxd (2.0.5-0ubuntu1~ubuntu14.04.1) trusty-backports; urgency=medium

  * Backport to trusty
  * Build using golang-1.6-go.
  * Arch-restrict all binaries to amd64, arm64, armhf, i386, ppc64el.
    powerpc isn't supported by golang-go.
  * Use bundled dependencies instead of archive versions (which don't exist).

 -- Stéphane Graber <stgraber@ubuntu.com>  Tue, 25 Oct 2016 14:14:43 -0400

lxd (2.0.5-0ubuntu1~ubuntu16.04.1) xenial; urgency=medium

  * New upstream bugfix release (2.0.5) (LP: #1632152)
    - Support for AppArmor namespacing and stacking
    - Rework LXD daemon logging to be cleaner and more generally useful
    - "lxc info CONTAINER" now shows the name of the remote for the container
    - Client errors now include the remote the container is on
    - /snap/bin is included to PATH if present in the container
    - doc: Add txqueuelen tweak.
    - doc: Clarify that user_subvol_rm_allowed is needed for btrfs nesting
    - doc: Fix the table style of environment.md
    - doc: Fix typos in production-setup.md
    - doc: Remove trailing spaces in production-setup.md
    - doc: Spacing cleanup
    - extras: Containers state checking for start, stop and exec commands
    - extras: Fixed container convert from LXC to LXD
    - fuidshift: expand symlinks to last path component
    - lxc: Drop unused httpAddr property
    - lxc/exec: Document lxc exec -- args
    - lxc/exec: Use os.LookupEnv from go 1.5 to find environment vars
    - lxc: Fix spacing alignment in config.go's examples
    - lxc/help: Send error to stdout
    - lxd/apparmor: Be less restrictive when unprivileged
    - lxd-bridge: Fail on dnsmasq failure
    - lxd-bridge: Fix crash in lxd-bridge-proxy
    - lxd: Consistently handle name conflicts
    - lxd/container: Allow unsetting any config key
    - lxd/container_lxc: handle xattrs
    - lxd/container: Retry generating petnames
    - lxd/container: Return an error on "restart" without force when paused
    - lxd/container: Rework container operation locking
    - lxd/daemon: Do our own socket activation
    - lxd/db: Fix int64 handling
    - lxd/db: Make a database backup on schema updates
    - lxd/db: Rework DB schema updates
    - lxd/image: Fix support for lzma alone file format
    - lxd/image: Tweak squashfs for low-memory systems
    - lxd/init: Change default host to all (::)
    - lxd/init: Change validation functions for consistency
    - lxd/init: Default to "dir" when "zfs" isn't available
    - lxd/init: Don't fail when passed "all" as an IP
    - lxd/init: Enable compression on new zfs pools
    - lxd/init: Fix listed default value for ZFS pool
    - lxd/init: use more intelligent logic for partition sizing
    - lxd/migration: Fix copying across different CoW based backend
    - lxd/migration: Also show warnings on c/r errors
    - lxd/migration: Bump ghost limit
    - lxd/migration: Don't use ActionScript if it's not available
    - lxd/migration: Preserve snapshot configuration
    - lxd/migration: Resume dumped container on failed restore
    - lxd/migration: Use liblxc's new preserves_inodes feature
    - lxd/network: Detect bonds
    - lxd/network: Detect openvswitch
    - lxd/network: Fix networkIsInUse
    - lxd/network: Move and rename isOnBridge
    - lxd/profile: Cleaner error on existing profile name
    - lxd/profile: Properly cleanup on profile removal
    - lxd/storage: Copy everything on container copy
    - lxd/storage: Extra checks and config for ZFS pools
    - Makefile: Don't recursively include test deps
    - README: Add AppVeyor badge (Windows testing)
    - shared: Add GetOwner stub for Windows
    - shared: Generate client certificate with proper extended usage info
    - shared: Make TestReaderToChannel transfer smaller
    - shared: New RunCommand wrapper function
    - tests: Add a test to make sure we don't accidentally include new deps
    - tests: add test for GetAllXattr()
    - tests: Fix apparmor version check
    - tests: Fix for newer shellcheck
    - tests: Force UTC timezone
    - tests: Only check leftovers on active LXD
    - tests: skip tests when xatts are not supported
  * Update debian/copyright
  * Drop go-systemd dependency

 -- Stéphane Graber <stgraber@ubuntu.com>  Mon, 10 Oct 2016 19:34:53 -0400

=== debian/rules ===
--- 
+++ 
@@ -50,7 +50,6 @@
 	# has installed it, as appropriate.
 
 	# Packaged dependencies
-	debian/helpers/link-from-installed github.com/coreos/go-systemd
 	debian/helpers/link-from-installed github.com/dustinkirkland/golang-petname
 	debian/helpers/link-from-installed github.com/golang/protobuf
 	debian/helpers/link-from-installed github.com/gorilla/context
